<?php

use Joomla\CMS\Factory;

class DatafeedsControllerDatafeeds extends JControllerLegacy
{
    public function __construct($config = [])
    {
        parent::__construct($config);
        $this->db= Factory::getContainer()->get('DatabaseDriver');
    }
    public function display($cachable = false, $urlparams = false)
    {
        $app = Factory::getApplication();
        $context    = 'com_datafeed.datafeeds.list.';
        $filter_order   = $app->getUserStateFromRequest($context.'filter_order', 'filter_order', 'feed', 'cmd');
        $search                         = $app->getUserStateFromRequest($context.'search', 'search', '', 'string');
        $filter_order   = $app->getUserStateFromRequest($context.'filter_order', 'filter_order', 'feed', 'cmd');
        $filter_state           = $app->getUserStateFromRequest($context.'filter_state', 'filter_state', '', 'word');
        $filter_order_Dir= $app->getUserStateFromRequest($context.'filter_order_Dir', 'filter_order_Dir', '', 'word');
        $limit       = $app->getUserStateFromRequest($context.'limit', 'limit', $app->getCfg('list_limit'), 'int');
        $limitstart      = $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
        $f_s0      = $app->getUserStateFromRequest($context.'f_s0', 'f_s0', '', 'string');
        $orderby     = "$filter_order $filter_order_Dir ";
        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order']     = $filter_order;
        $where = [];
        if ($f_s0) {
            $where[] = "field0 = '$f_s0'";
        }
        if ($search) {
            $where[] = ' feed LIKE '.$this->db->Quote('%'.$this->db->escape($search, true).'%', false);
            $lists['search']=$search;
        }
        if ($filter_state) {
            switch ($filter_state) {
                case 'P':
                    $where[] = 'published = 1';
                    break;
                case 'U':
                    $where[] = 'published = 0';
                    break;
                case 'A':
                    $where[] = 'published > 1';
                    break;
                case 'T':
                    $where[] = '(published = 1) AND (`last_update` + interval `freq` second< now())';
                    break;
                default:
                    ;
            }
        }

        $where  = count($where) ?join(' AND ', $where) : 1;

        $query = $this->db->getQuery(true);
        $query->select('COUNT(*)')->from('#__datafeeds')->where($where);
        $this->db->setQuery($query);
        $total = $this->db->loadResult();
        $pageNav = new JPagination($total, $limitstart, $limit);
        #groepen
        $sql = 'SELECT distinct field0 as f_s0,field0 as f_s1 FROM #__datafeeds order by field0' ;
        $this->db->setQuery($sql);
        if (!$this->db->execute()) {
            $app->enqueueMessage(JText::_('Operation Failed') . ': ' . $this->db->getErrorMsg(), 'error');
            $this->setRedirect('index.php?option=com_datafeeds&c=dataitems');
            return;
        }
        #$reflector = new ReflectionClass('JHTML'); echo $reflector->getFileName(); echo $reflector->getStartLine(); exit;
        $groeplist[]    = JHTML::_('select.option', '0', JText::_('FILTER_ON_SELECT0'), 'f_s0', 'f_s1');
        $groeplist  = array_merge($groeplist, $this->db->loadObjectList());
        $lists['groeplist'] = JHTML::_('select.genericlist', $groeplist, 'f_s0', 'onchange="document.adminForm.submit();"', 'f_s0', 'f_s1', $f_s0);
        $lists['state'] = JHTML::_('grid.state', $filter_state, 'Published', 'Unpublished', 'Attention', 'Scheduled');

        $query = $this->db->getQuery(true);
        $query->setLimit($pageNav->limitstart, $pageNav->limit);
        $query->select('feed_id as id,  field0,feed, last_update,published,feed_url,  UNIX_TIMESTAMP(`last_update` + interval `freq` second) - UNIX_TIMESTAMP()  as old')
           ->from('#__datafeeds')->where($where)->order($orderby) ;
 
        $this->db->setQuery($query);
        $rows = $this->db->loadObjectList();
        require_once(JPATH_COMPONENT.'/views/datafeeds.php');
        DatafeedsViewListfeeds::display($rows, $pageNav, $lists);
    }
    public function unpublish()
    {
        $jinput = Factory::getApplication()->input;
        $cid    = $jinput->get('cid', []);
        if ($cid) {
            $cids = implode(',', $cid);
            $q="update #__datafeeds set published=0,last_update='2012-01-01 00:01:01' where feed_id in ( $cids )";
            $this->db->setQuery($q);
            if (!$this->db->execute()) {
                $app->enqueueMessage(JText::_('Operation Failed') . ': ' . $this->db->getErrorMsg(), 'error');
                $this->setRedirect('index.php?option=com_datafeeds&c=dataitems');
                return;
            }
            $q="delete from  #__dataitems  where feed_id in ( $cids )";
            $this->db->setQuery($q);
            if (!$this->db->execute()) {
                $app->enqueueMessage(JText::_('Operation Failed') . ': ' . $this->db->getErrorMsg(), 'error');
                $this->setRedirect('index.php?option=com_datafeeds&c=dataitems');
                return;
            }
            $link = 'index.php?option=com_datafeeds&c=datafeeds';
            $this->setRedirect($link, JText::_('FEEDS_UNPUBLISHED'));
        }
    }
    public function publish()
    {
        $jinput = Factory::getApplication()->input;
                $cid    = $jinput->get('cid', []);
        if ($cid) {
            $cids = implode(',', $cid);
            $q="update #__datafeeds set published=1 where feed_id in ( $cids )";
            $this->db->setQuery($q);
            if (!$this->db->execute()) {
                $app->enqueueMessage(JText::_('Operation Failed') . ': ' . $this->db->getErrorMsg(), 'error');
                $this->setRedirect('index.php?option=com_datafeeds&c=dataitems');
            }
            $link = 'index.php?option=com_datafeeds&c=datafeeds';
            $this->setRedirect($link, JText::_('FEEDS_PUBLISHED'));
        }
    }
    public function cron()
    {
        $link='components/com_datafeeds/cron/feedcron.php';
        $this->setRedirect($link, JText::_('IMPORT_READY'));
    }

    public function remove()
    {
        $jinput = Factory::getApplication()->input;

                $cid    = $jinput->get('cid', []);
        if ($cid) {
            $cids = implode(',', $cid);
            $q="delete from  #__datafeeds  where feed_id in ( $cids )";
            $this->db->setQuery($q);
            if (!$this->db->execute()) {
                $app->enqueueMessage(JText::_('Operation Failed') . ': ' . $this->db->getErrorMsg(), 'error');
                $this->setRedirect('index.php?option=com_datafeeds&c=dataitems');
                return;
            }
            $q="delete from  #__dataitems  where feed_id in ( $cids )";
            $this->db->setQuery($q);
            if (!$this->db->execute()) {
                $app->enqueueMessage(JText::_('Operation Failed') . ': ' . $this->db->getErrorMsg(), 'error');
                $this->setRedirect('index.php?option=com_datafeeds&c=dataitems');
                return;
            }
            $link = 'index.php?option=com_datafeeds&c=datafeeds';
            #$this->setRedirect($link, JText::_('FEEDS_REMOVED'));
            $this->setRedirect('index.php?option=com_datafeeds&c=datafeeds');
        }
    }
}
