<?php
//
// Copyright brambring.nl
// https://affiliatefeeds.nl
// joomla@brambring.nl
//
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
/**
 * Datafeeds Datafeeds Controller
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class DatafeedsControllerEdit extends JControllerLegacy
{
    public function __construct($config = [])
    {
        parent::__construct($config);
        $this->registerTask('edit', 'display');
        $this->registerTask('cancel', 'display');
        $this->registerTask('apply', 'save');
        $path       = JPATH_ADMINISTRATOR . '/components/com_datafeeds/cron';
        $this->file = $path . '/feeds.php';
    }
    /**
     * constructor (registers additional tasks to methods)
     * @return void
     */
    /**
     * Method to display the view
     *
     * @access  public
     */
    public function display($cachable = false, $urlparams = false)
    {
        $app    = JFactory::getApplication();
        $jinput = $app->input;
        $option = $jinput->get('option');
        $client = JApplicationHelper::getClientInfo($jinput->get('client', 0, 'int'));
        $content = file_get_contents($this->file);
        $task    = $jinput->get('task');
        $task    = $task ? $task : 'display';
        if ($content !== false) {
            require_once(JPATH_COMPONENT_ADMINISTRATOR . '/views/edit.php');
            DatafeedssViewedit::$task($content, $option, $client);
        } //$content !== false
        else {
            $msg = JText::sprintf('Operation Failed Could not open', $this->file);
            $app->redirect('index.php?option=' . $option . '&client=' . $client->id, $msg);
        }
    }
    public function save()
    {
        $app = JFactory::getApplication();
        $user = JFactory::getUser();
        $jinput = $app->input;
        $option = $jinput->get('option');
        if (!$user->get('isRoot')) {
            $app->enqueueMessage(JText::_('Operation Failed') . ': ' . JText::sprintf('Must be super administrator', $this->file));
            $app->redirect('index.php?option=' . $option . '&c=edit');
        } //!$user->get('isRoot')
        JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
        $client = JApplicationHelper::getClientInfo($jinput->get('client', 0, 'int'));
        $filecontent = $jinput->get('jform', [], 'array')['filecontent'];
        if (!$filecontent) {
            $app->enqueueMessage(JText::_('Operation Failed') . ': ' . JText::_('Content empty.'));
            $app->redirect('index.php?option=' . $option . '&client=' . $client->id);
        } //!$filecontent
        // Set FTP credentials, if given
        $return = JFile::write($this->file, $filecontent);
        if ($return) {
            $task = $jinput->get('task');
            switch ($task) {
                case 'apply':
                    $app->enqueueMessage(JText::_('feeds.php saved'));
                    $app->redirect('index.php?option=' . $option . '&task=edit&c=edit');
                    break;
                case 'save':
                default:
                    $app->enqueueMessage(JText::_('feeds.php saved'));
                    $app->redirect('index.php?option=' . $option . '&c=edit');
                    break;
            } //$task
        } //$return
        else {
            $app->enqueueMessage(JText::_('Operation Failed') . ': ' . JText::sprintf('Failed to open file for writing.', $this->file), 'error');
            $app->redirect('index.php?option=' . $option . '&c=edit');
        }
    }
}
