<?php
$server_name=$_SERVER['SERVER_NAME']??'cli';
ini_set(
    'user_agent',
    'Mozilla/5.0 (datafeeds fetcher '.$server_name.')'
);

function generic_cb(&$item)
{
    global $feed_opts;
    if (isset($item['description'])) {
        $item['description']=html_entity_decode(str_replace(["\t","\n"], ["   "," "], $item['description']), ENT_QUOTES, 'UTF-8');
        $item['description']=str_replace("\n", "<br />", $item['description']);
    } else {
        $item['description']='';
    }
    foreach (['url','image','price'] as $v) {
        if (isset($feed_opts[$v])) {
            if (isset($item[$feed_opts[$v]])) {
                $item[$v]=trim($item[$feed_opts[$v]]);
            } else {
                $item[$v]='';
            }
        }
    }
    foreach (['title',
    'field1','field2','field3','field4','field5','field6','field7','field8','field9',
    'field10','field11','field12','field13','field14','field15','field16','field17','field18','field19'
    ] as $v) {
        if (!empty($feed_opts[$v])) {
            if (isset($item[$feed_opts[$v]])) {
                $item[$v]=trim(html_entity_decode($item[$feed_opts[$v]], ENT_COMPAT, 'UTF-8'));
            } else {
                $item[$v]='';
            }
        } elseif (isset($item[$v])) {
            $item[$v]=trim(html_entity_decode($item[$v], ENT_COMPAT, 'UTF-8'));
        } else {
            $item[$v]='';
        }
    }
    $item['title'] = preg_replace("/<.*?>/", "", $item['title']);
    $item['feed']=$feed_opts['feed']??'';
    $item['field0']=$feed_opts['field0']??'';
    if (! empty($item['data']) && is_string($item['data'])) {
        $item['data']=json_decode($item['data']);
    }
    #performace ?
    # these if's are really no big spenders
    # feeds might contain links to different affiliate companies
    # like custom feeds

    if (! defined('DF_SKIP_DFREF')) {
        if (isset($item['url'])) {
            if (strpos($item['url'], 'DF-REF')) {
                $item['url']=str_replace('DF-REF', DFREF, $item['url']);
            } elseif (strpos($item['url'], 'tradedoubler')) {
                if (strpos($item['url'], '&url') !== false) {
                    $item['url']=str_replace('&url', '&epi='.DFREF.'&url', $item['url']);
                } else {
                    $item['url'].='epi('.DFREF.')';
                }
            } elseif (strpos($item['url'], 'webgains')) {
                $item['url']=str_replace('wgtarget', 'clickref='.DFREF.'&wgtarget', $item['url']);
            } elseif (strpos($item['url'], 'awin1')) {
                $item['url'].='&clickref='.DFREF;
            } elseif (strpos($item['url'], 'metaffiliation')) {
                $item['url'].='&argsite='.DFREF;
            }
        }
    }
}

function mini_cb(&$item)
{
    #deze omweg houdt de zaak compatible met de rechtstreekste manier van werken
    # (zonder sql)
    global $feed_opts;
    static $change=[ 'Prijs' => 'price', 'prijs' => 'price', 'groep' => 'field0', 'menu_0' => 'field0', 'menu_1' => 'field1', 'menu_2' => 'field2', 'menu_3' => 'field3', 'menu_4' => 'field4', 'menu_5' => 'field5', 'menu_6' => 'field6', 'menu_7' => 'field7', 'menu_8' => 'field8', 'menu_9' => 'field9', 'menu_10' => 'field10', 'menu_11' => 'field11', 'menu_12' => 'field12', 'menu_13' => 'field13', 'menu_14' => 'field14', 'menu_15' => 'field15', 'menu_16' => 'field16', 'menu_17' => 'field17', 'menu_18' => 'field18', 'menu_19' => 'field19', 'Select0' => 'field0', 'Select1' => 'field1', 'Select2' => 'field2', 'Select3' => 'field3', 'Select4' => 'field4', 'Select5' => 'field5', 'Select6' => 'field6', 'Select7' => 'field7', 'Select8' => 'field8', 'Select9' => 'field9', 'Select10' => 'field10', 'Select11' => 'field11', 'Select12' => 'field12', 'Select13' => 'field13', 'Select14' => 'field14', 'Select15' => 'field15', 'Select16' => 'field16', 'Select17' => 'field17', 'Select18' => 'field18', 'Select19' => 'field19', 'href' => 'url', ];
    if (isset($item['href'])) { //oud formaat
        foreach ($change as $o => $n) {
            if (empty($item[$n]) && !empty($item[$o])) {
                $item[$n]=$item[$o];
            }
        }
    }

    if (empty($item['feed'])) {
        $item['feed']=$feed_opts['feed'];
    }
    if (empty($item['field0'])) {
        $item['field0']=$feed_opts['field0'];
    }
    if (!defined('DF_SKIP_DFREF') && isset($item['url'])) {
        $item['url']=str_replace('DF-REF', DFREF, $item['url']);
    }
    if (! empty($item['data']) && is_string($item['data'])) {
                    $item['data']=json_decode($item['data']);
    }
}

if (file_exists(dirname(__FILE__)."/feeds.php")) {
    include_once(dirname(__FILE__)."/feeds.php");
}

if (! defined('DFREF')) {
    define('DFREF', 'DF-REF');
}

if (! defined('DF_LOAD_CHECK') && function_exists('sys_getloadavg')) {
    define('DF_LOAD_CHECK', true);
}
if (! defined('DF_LOAD_WAIT')) {
    define('DF_LOAD_WAIT', 60);
}
if (! defined('DF_LOAD_MAX')) {
    define('DF_LOAD_MAX', 10);
}
