<?php
#
# Copyright brambring.nl
# https://affiliatefeeds.nl
# joomla@brambring.nl
#

// no direct access
defined('_JEXEC') or die('Restricted access');


class TableDatafeeds extends JTable
{
    /**
     * Primary Key
     *
     * @var int
     */
    public $feed_id = null;
    public $feed = '';
    public $feed_url = '';
    public $title= 'not set';
    public $url= '';
    public $image= '';
    public $price= '';
    public $field0 = 'all';
    public $field1 = '';
    public $field2= '';
    public $field3 = '';
    public $field4 = '';
    public $field5 = '';
    public $field6 = '';
    public $field7 = '';
    public $field8 = '';
    public $field9 = '';
    public $field10 = '';
    public $field11 = '';
    public $field12= '';
    public $field13 = '';
    public $field14 = '';
    public $field15 = '';
    public $field16 = '';
    public $field17 = '';
    public $field18 = '';
    public $field19 = '';
    public $callback = 'generic_cb';
    public $class = 'AutoCSV';
    public $input_encoding = '';
    public $freq = 259200;
    public $last_update = '2001-01-01 01:01:01';
    public $published = 1;
    public $example = '';
    public $UID = '';
    public $example_raw = '';


    /**
     * Constructor
     *
     * @param object Database connector object
     */
    public function __construct(&$db)
    {
        parent::__construct('#__datafeeds', 'feed_id', $db);
    }
    public function setRef()
    {
        if ($merchant=$this->getAff()) {
            switch (strtolower($merchant)) {
                case 'tradetracker':
                    if (strpos($this->feed_url, "&r=") === false) {
                        $this->feed_url .= "&r=DF-REF";
                    };
                    break;
                case 'affiliate4you':
                    if (strpos($this->feed_url, "&linkinfo=") === false) {
                        $this->feed_url .= "&linkinfo=DF-REF";
                    };
                    break;
                case 'affiliate':
                    if (strpos($this->feed_url, "&ws=") === false || preg_match("/&ws=$/", $this->feed_url)||preg_match("/&ws=&/", $this->feed_url)) {
                        $this->feed_url .= "&ws=DF-REF";
                    };
                    break;
                default:
                    break;
            }
        }
    }
    public function getAff()
    {
        if ($this->feed_url) {
            if ((strpos($this->feed_url, 'csv') === false) && preg_match("#http://(.*?)([^\.]+)\.[^\.]+/#", $this->feed_url, $m)) {
                $aff=strtolower($m[2]);
                switch ($aff) {
                    # wat history in de naamgeving van de feeds.
                    case 'ds1':
                        $aff='Affiliate';
                        break;
                    default:
                        $aff=ucfirst($aff);
                }
                return  $aff ;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    public function getClass()
    {
        $class=false;
        if ($this->feed_url) {
            if (preg_match("#[=/](xml|csv)#i", $this->feed_url, $m)) {
                $type=strtolower($m[1]);
                switch ($type) {
                    case 'csv':
                            $class="AutoCSV";
                        break;
                    case 'xml':
                        if ($merchant=$this->getAff()) {
                            if (class_exists($merchant.'V2')) {
                                $class=$merchant.'V2';
                            } elseif (class_exists($merchant.'RSS')) {
                                $class=$merchant.'RSS';
                            }
                        }
                        break;
                }
            }
        }
        if (! $class) {
            if ($merchant=$this->getAff()) {
                if (class_exists($merchant.'RSS')) {
                    $class=$merchant.'RSS';
                }
            }
        }
        return $class;
    }

    public function fromXML($package = '')
    {
        if (! $package) {
            return;
        }
        if ($xml=JFactory::getXML($package)) {
            $this->feed='ok';
        } else {
            $this->feed='jammer';
        }
        foreach ($xml as $child) {
            $field=$child->name();
            $this->$field=(string)$child;
        }
        $this->feed_id=null;
    }
    public function store($updateNulls = false)
    {
        $convert['image']=['image_1','imageurl', 'img_small', 'image','img_medium','image_url'];
        $convert['title']=[ 'title', 'name', 'productname', 'accommodation_name','product_name','nome'];
        $convert['url']=[ 'producturl', 'link', 'url', 'deeplink'];
        $convert['price']=[ 'price', 'minimum_price', 'productprice'];
        $convert['field1']=[ 'country_of_destination', 'categorie', 'category', 'country', 'f_land', 'f_country', 'destination_country', 'land','c_0'];
        $convert['field2']=[ 'region_of_destination', 'categoriesub', 'subcategory', 'c_1', 'sub_category', 'region' ];
        $convert['field3']=[ 'city_of_destination', 'city', 'c_3', 'f_city', 'place', 'f_plaats' ];
        $convert['field9']=[ 'brand', 'vendor' ];
    
    
        $this->last_update = '2001-01-01 01:01:01';
        $freq=$this->freq;
        if (preg_match('#([0-9.]+) *([SMHDW])#', $freq, $m)) {
            $freq=$m[1];
            switch ($m[2]) {
                case 'W':
                    $freq=7*$freq;
                // no break
                case 'D':
                    $freq=24*$freq;
                // no break
                case 'H':
                    $freq=60*$freq;
                // no break
                case 'M':
                    $freq=60*$freq;
                // no break
                case 'S':
                    $freq=$freq;
                    break;
            }
            $this->freq=$freq;
        }
        if (!$this->freq) {
            $this->freq=259200;
        }
        #bepaalde karakters worden er bij de sql import uigehaald,
        #duidleijker om dat hier ook maar te doen.
        $this->feed= strtr($this->feed, "'/-&\"?_+#", "`         ");
        $this->feed=trim($this->feed);
        $this->class=trim($this->class);
        $this->feed=preg_replace("/  */", " ", $this->feed);
        $this->field0= strtr($this->field0, "'/-:&\"?_+#", "`         ");
        $this->field0=trim($this->field0);
        $this->field0=preg_replace("/  */", " ", $this->field0);
        if ($this->input_encoding) {
            if (strpos($this->input_encoding, '8859')) {
                $this->input_encoding='utf8_encode';
                JFactory::getApplication()->enqueueMessage('Encoding should be callable. Set to utf8_encode', 'warning');
            }
            if (!function_exists($this->input_encoding)) {
                JFactory::getApplication()->enqueueMessage("Encoding must be callable. function <strong>{$this->input_encoding}</strong> not found", 'error');
            }
        }
        if ($this->title == 'not set' && $this->example_raw) {
            $item=json_decode($this->example_raw, true);
            foreach ($convert as $k => $v) {
                foreach ($v as $most_used) {
                    if (isset($item[$most_used])) {
                        $this->$k=$most_used;
                        break;
                    }
                }
            }
            $this->setRef();
        }
        return  parent::store($updateNulls) ;
    }
    public function bind($src, $ignore = [])
    {
        $y=  parent::bind($src, $ignore) ;
        $freq=$this->freq;
        if (!$freq) {
            $freq='3 Days';
        } elseif (is_numeric($freq)) {
            $s=1;
            $m=$s*60;
            $h=$m*60;
            $d=$h*24;
            $w=$d*7;
            switch (true) {
                case ( $freq > $w ):
                    $freq=round($freq/$w, 1) . ' Weeks';
                    break;
                case ( $freq > $d ):
                    $freq=round($freq/$d, 1) . ' Days';
                    break;
                case ( $freq > $h ):
                    $freq=round($freq/$h, 1) . ' Hours';
                    break;
                case ( $freq > $m ):
                    $freq=round($freq/$m, 1) . ' Minutes';
                    break;
                default:
                    $freq=$freq . ' Seconds';
            }
            $this->freq=$freq;
        }

        return $y;
    }
}
