<?php

//
// Copyright brambring.nl
// https://affiliatefeeds.nl
// joomla@brambring.nl
//
#namespace Joomla\Component\Datafeeds\Site\Controller;

use Joomla\CMS\MVC\View\GenericDataException;
use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
\defined('_JEXEC') or die;

class DatafeedsController extends BaseController
{
    /**
     * Method to display the view.
     */
    public function display($cachable = false, $urlparams = false)
    {
        // Set a default view if none exists
        $jinput = Factory::getApplication()->input;
        if (!$jinput->get('view')) {
            //this is a bug in joomla
            $hash = strtoupper($_SERVER['REQUEST_METHOD']);
            if ('HEAD' == $hash) {
                $hash = 'GET';
            }
            $jinput->set('view', 'items');
        }
        /* naar mijn mening is het niet goed zetten van de layout
           een bug in joomla
        */
        $app = Factory::getApplication();
        $menus = $app->getMenu();
        $menu = $menus->getActive();
        if (!$jinput->get('layout', '', 'string') && isset($menu->query['layout'])) {
            $jinput->set('layout', $menu->query['layout']);
        }


        parent::display();
    }

    public function component()
    {
        $jinput = Factory::getApplication()->input;
        $jinput->set('view', 'items');
        $app = Factory::getApplication();
        $router = $app->getRouter();
        $router->setVar('format', '');
        $router->setVar('task', '');
        $document = Factory::getDocument();
        $document->setType('raw');
        parent::display();
    }

    public function module()
    {
    // too fetch module from an ajax request
    // not used by base component.
        $jinput = Factory::getApplication()->input;
        $module_id = $jinput->get('module_id', 0, 'int');
        $db = Factory::getDBO();
        $query = 'SELECT params'
            .' FROM #__modules AS m'
            .' WHERE m.id = '.(int) $module_id;
        $db->setQuery($query);

        if (null === ($params = $db->loadResult())) {
            throw new GenericDataException(JText::_('Error Loading Modules').$db->getErrorMsg(), 500);

            return false;
        }
        $a=json_decode($params);
        $a->ajax=1;
        $params=json_encode($a);
        $mod = JModuleHelper::getModule('mod_datamenu');
        $mod->id = $module_id;
        $mod->params = $params;

        echo JModuleHelper::renderModule($mod);
    }

    public function hits()
    {
        $jinput = Factory::getApplication()->input;
        $item = $jinput->get('item', 0, 'int');
        $hits = $jinput->get('hits', 0, 'int');
        $Itemid = $jinput->get('c', 0, 'int');
        $db = Factory::getDBO();
        $update = 'UPDATE LOW_PRIORITY #__dataitems SET hits = ( hits + '.$hits.' ) WHERE items_id = '.$item;
        $query = 'select sql_no_cache * from #__dataitems WHERE items_id = '.$item;
        $db->setQuery($update);
        $db->execute(); //pech als die niet goedgaat
        $db->setQuery($query);
        $product = $db->loadAssoc();
        header('Content-type: text/xml');
        $xml = '<item id="'.$item.'">';
        if (is_array($product)) {
            foreach ($product as $k => $v) {
                $xml .= '<'.$k.'><![CDATA['.$v.']]></'.$k.'>'."\n";
            }
        }
        if ($Itemid) {
            $producturl = rtrim(JURI::Base(), '/').JRoute::_("index.php?option=com_datafeeds&view=items&Itemid=$Itemid&qt=".urlencode($product['title']));
            $xml .= '<producturl><![CDATA['.$producturl.']]></producturl>'."\n";
        }

        $xml .= '</item>';

        echo '<?xml version="1.0" encoding="UTF-8"?'.'>';
        echo "\n";
        echo $xml;
        exit;
    }

    public function go()
    {
        $app = Factory::getApplication();
        $jinput=$app->input;
        $db = Factory::getDBO();
        $item = $jinput->get('item', 0, 'int');
        if ($item and is_numeric($item)) {
            $query = 'select sql_no_cache url,feed,title from #__dataitems WHERE items_id = '.$item;
            $update = 'UPDATE LOW_PRIORITY #__dataitems'.' SET hits = ( hits + 1 ) WHERE items_id = '.$item;
        }

        $db->setQuery($query);
        $product = $db->loadObject();

        if ($product && $product->url) {
            $db->setQuery($update);
            $db->execute(); //pech als die niet goedgaat
            $p = 'I'.$item.'-';
            $p .= '-'.$product->feed;
            $p .= '-'.$product->title;
            $product->url = str_replace(['&amp;', 'DF-REF'], ['&', $p], $product->url);
            $app->redirect($product->url, false);
        } else {
            /*this should never happen on 'normal' sites*/
            $app->redirect('/', false);
        }
        //legacy ....
        $r = $jinput->get('r', '', 'string');
        if ($r) {
            $app->redirect(preg_replace("/^\[|\]$/", '', $r));
        }
        $app->redirect('/', false);
    }

    public function search()
    {
        $a = ['q1', 'q2', 'q3', 'q4', 'q5', 'q6', 'q7', 'q8', 'q9', 'min', 'max', 'mm', 'so', 'q', 'sort', 'order'];
        $app = Factory::getApplication();
        $jinput=$app->input;
        $mode= Factory::getConfig()->get('sef', false);
        $post['option'] = 'com_datafeeds';
        $post['Itemid'] = $jinput->post->get('Itemid', null, 'int');
        foreach ($a as $v) {
            if ($q = $jinput->post->get($v, '', 'string')) {
                if ($mode) {
                    $post[$v] = trim($q);
                } else {
                    $post[$v] =trim(urldecode($q)); //not sure thi is still needed
                }
            }
        }

        $uri = JURI::getInstance();
        $uri->setQuery($post);

        $link = JRoute::_('index.php'.$uri->toString(['query', 'fragment']), false);
        $app->redirect($link, false);
    }
}
