<?php

//
// Copyright brambring.nl
// https://affiliatefeeds.nl
// joomla@brambring.nl
//
defined('_JEXEC') or die();
//legacy should not be used anymore
if (!defined('_DATAFEEDS_LEVELS')) {
    define('_DATAFEEDS_LEVELS', 19);
}

if (file_exists(dirname(__FILE__).'/xhelpers.php')) {
    include_once dirname(__FILE__).'/xhelpers.php';
}

if (!defined('DF_IMAGE')) {
    define('DF_IMAGE', '`image`');
}
if (!defined('DF_CLICK')) {
    define('DF_CLICK', 'index.php?option=com_datafeeds&amp;task=go&amp;format=raw&amp;');
}

function price2minmax($value, $sequence)
{
    echo 'removed';

    return false;
}
function pricequery($min, $max)
{
    if (!$min && !$max) {
        return '';
    } // fail safe
    if ($max && $min) {
        if ($max < $min) {
            $x = $max;
            $max = $min;
            $min = $x;
        }

        return " (`price` >= $min AND `price` <= $max) ";
    }
    if ($max) {
        return " (`price` < $max )";
    }

    return "( `price` >= $min )";
}
    //$query=$low_value?"($max_query AND $min_query)":$max_query;
function where_price($field, $value, $sequence)
{
    $first = 0;
    $tot_prijs = JText::_('TOTPRIJS');
    $tot_munt = JText::_('TOTMUNT');
    $value = trim(str_replace([$tot_prijs, $tot_munt], ['', ''], $value));
    foreach (explode(',', $sequence) as $r) {
        list($a, $b) = explode('-', $r);
        $first = $first ? $first : $b;
        if ($value <= $a) {
            continue;
        }
        $floor = "floor($b*ceil($field/$b))";
        if ($a) {
            $query = "IF ( $field > $a,$floor,0)";
        } else {
            $query = $floor;
        }
    }
    $query = "IF ($field=0,$first,$query)";

    return [$value, $query];
}

function compile_price($field, $sequence)
{
    $first = 0;
    if ('price' != $field) {
        return $field;
    }
    $tot_prijs = JText::_('TOTPRIJS');
    $tot_munt = JText::_('TOTMUNT');
    foreach (explode(',', $sequence) as $r) {
        list($a, $b) = explode('-', $r);
        $first = $first ? $first : $b;
        $floor = "floor($b*ceil($field/$b))";
        if ($a) {
            $query = "IF ( $field > $a,$floor,$query)";
        } else {
            $query = $floor;
        }
    }
    return "concat_ws(' ', '$tot_prijs',IF ($field=0,$first,$query) ,'$tot_munt')";
}

function make_group_select($field, $group)
{
    $db = JFactory::getDBO();
    $groep_array = [];
    $not_groep_array = [];
    if ('Empty' == $field) {
        return 1;
    }
    foreach (explode(',', $group) as $g) {
        if (strlen($g)) {
            if ('-' === $g[0]) {
                $g = substr($g, 1);
                $not_groep_array[] = $db->Quote($g);
            } else {
                $groep_array[] = $db->Quote($g);
            }
        }
    }
    if (count($groep_array)) {
        $groep = join(',', $groep_array);

        return "$field in ($groep)";
    }
    if (count($not_groep_array)) {
        $not_groep = join(',', $not_groep_array);

        return "$field not in ($not_groep)";
    }

    return 1;
}

function make_urlencoded($add)
{
    $slug = [];
    if (is_array($add)) {
        foreach ($add as $k => $v) {
            if (is_array($v)) {
                foreach ($v as $value) {
                    $slug[] = $k.'[]='.urlencode($value);
                }
            } else {
                $slug[] = "$k=".urlencode($v);
            }
        }
    }

    return join('&', $slug);
}
function make_qQuery($q, &$db)
{
    static $queries = [];
    $query = [];
    $jinput = JFactory::getApplication()->input;

    $a = $jinput->get('areas', '', 'string');
    $exact = $jinput->get('exact', 0, 'int');
    if ('' == $a && defined('DF_AREAS')) {
        $a = DF_AREAS;
    }

    if ('' == $a) {
        $areas = [0 => '0', 1 => '1', 2 => '2', 3 => '3', 4 => '4', 5 => '5', 6 => '6', 7 => '7', 8 => '8', 9 => '9', 't' => 't', 'd' => 'd', 'f' => 'f'];
    } else {
        $areas = array_flip(explode(',', $a));
    }
    if (!defined('DF_FEED_SEARCH')) {
        unset($areas['f']);
    }
    if (!defined('DF_DESCRIPTION_SEARCH')) {
        unset($areas['d']);
    }
    if (!defined('DF_TITLE_SEARCH')) {
        unset($areas['t']);
    }

    $md5 = md5(join('', $areas).$q.$exact);
    if (isset($queries[$md5])) {
        return $queries[$md5];
    }
    foreach (explode('>', $q) as $v) {
        $ors = [];
        $ands = [];
        $nots = [];
        preg_match_all("/([-\*])?(\"[^\"]*\"|'[^']*'|\\S+)/", $v, $terms, PREG_SET_ORDER);

        foreach ($terms as $term) {
            $word = trim($term[2], '\'"');
            if ($exact) {
                $word = ' = '.$db->Quote($db->Escape($word, true), false);
            } else {
                $word = ' LIKE '.$db->Quote('%'.$db->Escape($word, true).'%', false);
            }
            $wheres2 = [];
            for ($i = 0; $i <= 19; ++$i) {
                if (isset($areas[$i])) {
                    $wheres2[] = 'field'.$i.$word;
                }
            }
            if (isset($areas['f'])) {
                $wheres2[] = '`feed` '.$word;
            }

            if (!$exact && isset($areas['d'])) {
                $wheres2[] = '`description` '.$word;
            }
            if (isset($areas['t'])) {
                $wheres2[] = '`title` '.$word;
            }
            if (count($wheres2)) {
                $this_term = implode(' OR ', $wheres2);
                if ('-' == $term[1]) {
                    $this_term = ' NOT ( '.$this_term.')';
                    $nots[] = $this_term;
                } elseif ('*' == $term[1]) {
                    $ands[] = $this_term;
                } else {
                    $ors[] = $this_term;
                }
            }
        }
        if (count($ors)) {
            if (count($ands)) {
                $ands[] = '('.implode(') OR (', $ors).')'."\n";
            } else {
                $ands[] = '('.implode(') AND (', $ors).')'."\n";
            }
        }
        if (count($nots)) {
            $ands[] = '('.implode(') AND (', $nots).')'."\n";
        }
        if (count($ands)) {
            $query[] = '('.implode(') AND (', $ands).')'."\n";
        }
    }
    if (count($query)) {
        $query_string = '(('.implode(') OR (', $query).'))'."\n";
    } else {
        $query_string = '1';
    }
    $queries[$md5] = $query_string;

    return $query_string;
}

if (!function_exists('df_money_format')) {
    function df_money_format(float $f) : string
    {
        if (class_exists('NumberFormatter')) {
            $locale=JFactory::getLanguage()->getLocale()[0];
            $fmt = new \NumberFormatter($locale, NumberFormatter::CURRENCY);
            $fmt->setSymbol(NumberFormatter::CURRENCY_SYMBOL, '');
            return $fmt->formatCurrency($f, "");
        } else {
                $locale_info = localeconv();
            return number_format($f, 2, $locale_info['mon_decimal_point'], $locale_info['mon_thousands_sep']);
        }
    }

}
if (!function_exists('df_title')) {
    function df_title($f = '', $d = [])
    {
        return $f.'|'.join(' - ', $d);
    }
}
if (!function_exists('df_alt')) {
    function df_alt($str = '')
    {
        return 'Product';
    }
}
if (!function_exists('df_select')) {
    function df_select($f, $s, $not = false)
    {
 // weird order historical
        static $db = false;
        if (!$db) {
            $db = JFactory::getDBO();
        }

        $t = $db->Quote($s);
        if (false === $not) {
            return  "`$f` = $t";
        } else {
            return  "`$f` not in ('',$t)";
        }
    }
}
