<?php

//
// Copyright brambring.nl
// https://affiliatefeeds.nl
// joomla@brambring.nl
//
//
defined('_JEXEC') or die();

class DatafeedsModelItems extends JModelList
{
    /**
     * Gets the greeting.
     *
     */
    private $datacount = null;
    private $dataitems = null;
    private $where = null;
    private $aantal = 20;
    private $where_level = 0;
    private $select = [];
    private $title = [];
    private $fields = [];
    private $singleitem = false;
    /*
    var $limitnext=false;
    */
    private $alias;
    private $_protection = 0;
    private $jinput;
    private $_seen = 0;
    private $menu_id;
    private $maxq = 0;
    private $chain = 0; // is it a nice path /term/term2/term3
    private $group_order_select = '';
    private $group_order = '';
    private $is_grouped = false;
    private $smart_group = false;

    private function getInt($name, $default = 0)
    {
        return $this->jinput->get($name, $default, 'int');
    }
    private function getVar($name, $default = '')
    {
        return $this->jinput->get($name, $default, 'string');
    }
    private function setVar($name, $value)
    {
        return $this->jinput->set($name, $value);
    }
    public function __construct()
    {
        parent::__construct();
        $app = JFactory::getApplication();
        $this->db = JFactory::getDBO();
        $this->jinput = $app->input;
        $menus = $app->getMenu();
        $menu = $menus->getActive();

        $locale=JFactory::getLanguage()->getLocale()[0];
        setlocale(LC_MONETARY, $locale);


        if ($menu && 'com_datafeeds' == $menu->component) {
            $this->menu_id = $menu->id;
            $this->params = $app->getParams();
            $this->alias = $menu->alias;
            $this->name = $menu->name??'';
        } else {  // ajax style request
            $_itemid = $this->getInt('Itemid', 0);
            if ($_itemid) {
                $menus->setActive($_itemid);
                //trac 101 $menus->setDefault($_itemid); # is deze nog nodig ?
                $menu = $menus->getActive();
                $this->menu_id = $menu->id;
                $this->alias = $menu->alias;
                $this->params = new JRegistry($menu->params);
            } else {
                $this->params = new JRegistry('');
            }
        }

        $this->baselink = 'index.php?option=com_datafeeds&view=items&Itemid='.$this->menu_id;
        $this->select['f'] = $this->getVar('qf', '');
        $this->select['t'] = $this->getVar('qt', '');
        $this->select['q'] = $this->getVar('q', '');
        $this->select['id'] = $this->getInt('id', 0);
        if ($this->select['f']) {
            $this->title['f'] = $this->select['f'];
        }
        if ($this->select['t']) {
            $this->title['t'] = $this->select['t'];
        }
        if ($this->select['q']) {
            $this->title['q'] = $this->select['q'];
        }
        $this->select[0] = $this->getVar('q0', '');
        for ($v = 1; $v <= 9; ++$v) {
            $this->select[$v] = $this->getVar('q'.$v, '');
            if ($this->select[$v]) {
                if (false !== $this->chain && ($v == $this->chain + 1)) {
                    $this->chain = $v;
                } else {
                    $this->chain = false;
                }
                $this->maxq = $v;
                if (is_array($this->select[$v])) {
                    $this->title[$v] = join(' ', $this->select[$v]);
                } else {
                    $this->title[$v] = $this->select[$v];
                }
            }
        }
        if (($m = $this->getVar('mm', ''))) {
            $x = explode(',', $m);
            $this->setVar('min', $x[0]);
            $this->setVar('max', $x[1]);
        }
        if (($m = $this->getVar('so', ''))) {
            $x = explode(',', $m);
            if (count($x)) {
                $this->setVar('sort', $x[0]);
                $this->setVar('order', $x[1]);
            }
        }
        if (!$this->select['t'] && !$this->select['id']) {
            $this->select['min'] = $this->getVar('min', '');
            $this->select['max'] = $this->getVar('max', '');
        } else {
            $this->select['min'] = '';
            $this->select['max'] = '';
        }

        $this->limitstart = $this->getInt('limitstart', 0);
        if ('feed' == $this->getVar('format', '')) {
            $this->params->set('aantal0', $app->getCfg('feed_limit'));
            $this->params->set('aantal1', $app->getCfg('feed_limit'));
            $this->params->set('sorteer0', 'items_id');
            $this->params->set('sorteer1', 'items_id');
            $this->params->set('volg0', 'desc');
            $this->params->set('volg1', 'desc');
        }
        if ($num = $this->getInt('num', 0)) {
            if ($num > 0 && $num < 100) {
                $this->params->set('aantal0', $num);
                $this->params->set('aantal1', $num);
            }
        }
        // TEST LIMITNEXT
        /*
        if ( defined ('DF_LIMITNEXT') ) {
            $this->limitnext=DF_LIMITNEXT;
        }
        */
        if (function_exists('fix_link')) {
            fix_link($this->getWhere(true));
        }
        $this->compile_query();
        $datacount = $this->getDatacount();
        $slug_level = -1;
        // TEST LIMITNEXT
        /*
        if ( $this->limitnext && ($datacount < 1 )) {
            $this->limitnext=false;
            $this->datacount=null;
                    $this->dataitems=null;
                    $this->compile_query();
            $this->multipagina=0;
                    $datacount= $this->getDatacount();
        }
        */
        //$this->compile_query();
        //  onderstaande zorgt voor redirects als er niets gevonden wordt
        while (($datacount < 1) || ($this->limitstart >= $datacount)) {
            if (($datacount > 0) && ($this->limitstart >= $datacount)) {
                $slug_level = 9;
                $this->limitstart = 0;
                $this->setVar('limitstart', 0);
            } elseif ($this->select['q']) {
                $this->select['q'] = '';
                $this->setVar('q', '');
                $slug_level = 9;
            } elseif ($this->select['id']) {
                $this->select['id'] = '';
                $this->setVar('id', '');
                $slug_level = 9;
            } elseif ($this->select['f']) {
                $this->setVar('qf', '');
                $this->select['f'] = '';
                $slug_level = 9;
            } elseif ($this->select['t']) {
                $this->setVar('qt', '');
                $this->select['t'] = '';
                $slug_level = 9;
            } elseif ($this->select['min']) {
                $this->setVar('min', '');
                $this->setVar('max', '');
                $this->setVar('mm', '');
                $this->select['min'] = '';
                $this->select['max'] = '';
                $slug_level = 9;
            } else {
                for ($v = 9; $v >= 1; --$v) {
                    if ($this->select[$v]) {
                        $this->setVar('q'.$v, '');
                        $this->select[$v] = '';
                        $slug_level = $v - ($this->select['t'] ? 0 : 1); // in nieuwe structuur komt 't' niet meer voor
                        $v = -1;
                    }
                }
            }
            if ($slug_level > -1) {
                if (defined('DF_REQUERY')) {
                    if (!defined('DF_DID_REQUERY')) {
                        define('DF_DID_REQUERY', 1);
                    }
                    $document = JFactory::getDocument();
                    $document->setMetaData('robots', 'NOinDEX,follow');
                    if (!defined('DF_REQUERY_200')) {
                        header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found');
                        header('Status: 404 Not Found');
                    }

                    if (empty($this->select['t'])) {
                        if (!$this->_seen) {
                            if ('tmpl' == $this->getVar('format', '')) {
                                echo '<!--'.DF_REQUERY.'-->';
                            } else {
                                echo DF_REQUERY;
                            }
                            $this->_seen = true;
                        }
                    }

                    ++$this->_protection;
                    if ($this->_protection > 25) {
                        error_log($this->_protection.' '.$datacount.'-'.join(' ', $this->where));

                        return;
                    }
                    $this->datacount = null;
                    $this->dataitems = null;
                    $this->compile_query();
                    $datacount = $this->getDatacount();
                } else {
                    $redirect = $this->baselink;
                    if ($f = $this->getInt('ajax', 0)) {
                        $redirect .= '&ajax='.$f;
                    }
                    if ($this->select['t']) {
                        $redirect .= '&qt='.urlencode($this->select['t']);
                    }
                    if ($this->select['id']) {
                        $redirect .= '&id='.urlencode($this->select['id']);
                    }
                    if ($this->select['f']) {
                        $redirect .= '&qf='.urlencode($this->select['f']);
                    }
                    for ($v = $slug_level; $v >= 1; --$v) {
                        if ($this->select[$v]) {
                            $redirect .= "&q$v=".urlencode($this->select[$v]);
                        }
                    }
                    if ($f = $this->getVar('format', '')) {
                        $redirect .= '&format='.$f;
                    }
                    if ($f = $this->getVar('tmpl', '')) {
                        $redirect .= '&tmpl='.$f;
                    }
                    $redirect = str_replace('&amp;', '&', JRoute::_($redirect));
                    if (defined('DF_REDIRECT_MSG')) {
                        $session = JFactory::getSession();
                        $session->set('application.queue', [['message' => DF_REDIRECT_MSG, 'type' => 'message']]);
                    }
                    header("Location: $redirect", true, 301);
                    exit;
                }
            } else {
                return;
            }
        }
    }

    public function compile_query()
    {
        $minprice = false;
        $maxprice = false;
        $group_select = '';
        $where = [];
        $select_sql = [];

        for ($v = 9; $v >= 0; --$v) {
            ${"field$v"} = $this->params->get("field$v", "field$v");
            ${"select$v"} = $this->select[$v];
            if ('Empty' == ${"field$v"}) {
                if (${"select$v"}) {
                    $this->where = false;

                    return;
                }
            } else {
                $this->fields[$v] = ${"field$v"};
            }
        }
        // TEST LIMITNEXT
        /*
        if ( $this->limitnext && $this->limitnext >= $this->maxq && isset($this->fields[$this->maxq+1]) ) {

            $where['limitnext']=$this->fields[$this->maxq+1] . ' = ""';
        }
        */

        $sorteer = $this->params->get('sorteer0', 'items_id');
        $volgorde = $this->params->get('volg0', 'desc');

        $field0_2 = $this->params->get('field0_2', '');
        $groep_2 = $this->params->get('groep_2', '');
        $groep = $this->params->get('groep', $this->getVar('q0', ''));

        $where_group[] = make_group_select($field0, $groep);

        if ($field0_2 and $groep_2) {
            $where_group[] = make_group_select($field0_2, $groep_2);
        }

        if ($sqlfilter = $this->params->get('sqlfilter', '')) {
            $where[] = ' ( '.$sqlfilter.' ) ';
        }

        $limitstart = $this->limitstart;
        if ((!empty($this->select['min']) || !empty($this->select['max']) ) && ($this->params->get('siblings', 'Empty') != $group_select)) {
            $groepeer = 0;
        } else {
            $groepeer = $this->params->get('groepeer', '0');
        }
        $groep_alles = $this->params->get('groep_alles', '0');

        $verberg = $this->params->get('verbergurl', 1);
        $select_sql[] = '`items_id`, `feed_id`, `feed`, `hits`, `description`, `title`, `price`, 
		`field0`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, 
		`field10`, `field11`, `field12`, `field13`, `field14`, `field15`, `field16`, `field17`, `field18`, `field19`, 
`id`,  `data`,`price` AS pprice';
        $select_sql[] = DF_IMAGE.' AS image';
        if ($verberg) {
            $base = JURI::base().DF_CLICK;
            $select_sql[] = "CONCAT('${base}item=',`items_id`) AS url";
            $select_sql[] = '`url` AS rurl';
        } else {
            $select_sql[] = 'url';
        }
        $this->select_sql = join(',', $select_sql);

        $this->where_level = 0;
        if ($this->select['f']) {
            $where[] = df_select('Feed', $this->select['f'], false);
        }
        if ($this->select['t']) {
            $this->singleitem = true;
            $where[] = df_select('Title', $this->select['t'], false);
        }
        if ($this->select['id']) {
            $this->singleitem = true;
            $where[] = df_select('items_id', $this->select['id'], false);
        }
        for ($v = 1; $v <= 9; ++$v) {
            $f = ${"field$v"};
            if (('Empty' != $f)) {
                $s = $this->select[$v];
                if ($s) {
                    $where[] = df_select($f, $s, false);
                    ++$this->where_level;
                }
            }
        }

        $minprice = $this->select['min'] ??  $this->params->get('min_price', 0);
        $maxprice = $this->select['max'] ??  $this->params->get('max_price', 0);
        if (($minprice || $maxprice) &&
                     ($pricequery = pricequery($minprice, $maxprice))) {
            $where[] = $pricequery;
        }

        if ($this->where_level > 0) {
            $this->multipagina = $this->params->get('multi1', 0);
            $aantal = $this->params->get('aantal1', 20);
            //$sorttest=$this->params->get("sorteer".$this->where_level,$this->params->get("sorteer1",'default'));
            $sorttest = $this->params->get('sorteer1', 'default');
            if ('default' != $sorttest) {
                $volgorde = $this->params->get('volg1', 'desc');
                $sorteer = $sorttest;
            }
        } else {
            $aantal = $this->params->get('aantal0', 20);
            $this->multipagina = $this->params->get('multi0', 0);
        }

        if (function_exists('custom_sort')) {
            if ($a = custom_sort($this->getWhere(true))) {
                $sorteer = $a['sort'];
                $volgorde = $a['order'];
            }
        }

        if ('0' != $groepeer) {
            if (('1' == $groepeer)) {
                $group_select = $field1;
            } else {
                $group_select = $groepeer;
            }
            if ($this->where_level > 0) {
                switch ((int) $groep_alles) {
                    case 0:
                        $group_select = '';
                        break;
                    case 1:
                        break;
                    default:
                        $this->smart_group = true;
                        $v = $this->maxq + 1;
                        if ($v > $groep_alles) {
                            $group_select = '';
                        } else {
                            $group_select = defined('DF_GROUP_ADAPT') ? ${"field$v"} : $group_select;
                            $sorteer = ('Empty' == $group_select) ? $sorteer : $group_select;
                            $volgorde = ('Empty' == $group_select) ? $volgorde : 'asc';
                        }
                }
                $group_select = 'Empty' == $group_select ? '' : $group_select;
            }
        }

        if (($s = $this->getVar('sort', ''))) {
            switch ($s) {
                case 'h':
                    $sorteer = 'Hits';
                    break;
                case 'p':
                    $sorteer = 'price';
                    break;
                case 'price':
                    $sorteer = 'price';
                    break;
                case 'a':
                    $sorteer = 'items_id';
                    break;
                case 'adddate':
                    $sorteer = 'items_id';
                    break;
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                        $sorteer = !empty($this->fields[$s])?$this->fields[$s]:'items_id';
                    break;
                default:
                    if (in_array($s, [
                    'field0', 'field1', 'field2', 'field3', 'field4', 'field5', 'field6', 'field7', 'field8', 'field9',
                    'field10', 'field11', 'field12', 'field13', 'field14', 'field15', 'field16', 'field17', 'field18', 'field19',
                    'price', 'feed', 'title', 'hits',  'rand()' ])) {
                            $sorteer = $s;
                    }
            }
        }

        if (($v = $this->getVar('order', ''))) {
            switch ($v) {
                case 'a':
                    $volgorde = 'asc';
                    break;
                case 'd':
                    $volgorde = 'desc';
                    break;
                default:
                    if (in_array(strtolower($v), ['asc', 'desc'])) {
                        $volgorde = $v;
                    }
            }
        }
        if ('rand()' == $sorteer) {
            $this->order = "order by rand() $volgorde";
        } else {
            if ($group_select) {
                $this->group_order = "order by value $volgorde,items_id";
                if (false !== stristr($volgorde, 'asc')) {
                    $this->group_order_select = ',min(`'.$sorteer.'`) AS value';
                } else {
                    $this->group_order_select = ',max(`'.$sorteer.'`) AS value';
                }
            }
            $this->order = "order by `$sorteer` $volgorde,items_id";
        }

        if ($this->select['q']) {
            if ($this->params->get('siblings', 'Empty') != $group_select) {
                $group_select = '';
            }
            $this->multipagina = true;
            $where[] = make_qQuery($this->select['q'], $this->db);
        } else {
            if ($this->where_level < 1 && !$this->singleitem) {
                $field0_fp = $this->params->get('field0_fp', '');
                $groep_fp = $this->params->get('groep_fp', '');
                if ($field0_fp and $groep_fp) {
                    $where[] = make_group_select($field0_fp, $groep_fp);
                }
                if ($sqlfilter_fp = $this->params->get('sqlfilter_fp', '')) {
                    $where[] = ' ( '.$sqlfilter_fp.' ) ';
                }
            }
        }
        $this->sorteer = $sorteer;
        $this->aantal = $aantal;
        $this->volgorde = $volgorde;
        $this->group_select = $group_select;

        if (function_exists('custom_where')) {
            $where_group[]=custom_where($this->getWhere(true));
        }

        $this->where_group = join(' AND ', $where_group);
        $where[] = $this->where_group;

        $this->where = $where;

        return 1;
    }

    public function getSiblingfield()
    {
        return $this->params->get('siblings', 'Empty');
    }

    public function setSiblingGroup($a)
    {
        $this->params->set('siblinggroup', $a);
    }

    public function getSiblings($fields = false)
    {
        if (defined('ELASTIC')) {
            return $this->siblings;
        }

        $siblings = [];
        $select = [];
        if (null === $this->dataitems || 0 === count($this->dataitems)) {
            return $siblings;
        }
        $siblingfield = $this->params->get('siblings', 'Empty');
        if ('Empty' === $siblingfield || '' === $siblingfield) {
            return $siblings;
        }
        $siblingcount = $this->params->get('siblingcount', 5);
        $siblinggroup = $this->params->get('siblinggroup', 'Empty');
        $siblingsort = $this->params->get('siblingsort', 'items_id');
        $siblingvolg = $this->params->get('siblingvolg', 'DESC');
        $order = " ORDER BY `$siblingsort` $siblingvolg";

        if (!('Empty' === $siblinggroup || '' === $siblinggroup)) {
            $group = ' GROUP BY `'.trim($siblinggroup, '`').'`';
        } else {
            $group = '';
        }

        foreach ($this->dataitems as $item) {
            $field = $item[$siblingfield];
            $select = $this->db->Quote($field);
            $where = [];
            $where[] = $this->where_group;
            $where[] = '`'.$siblingfield.'` = '.$select;
            if ($sqlfilter = $this->params->get('sqlfilter', '')) {
                                            $where[] = ' ( '.$sqlfilter.' ) ';
            }


            if (false !== $fields) {
                foreach ($fields as $v) {
                    $where[] = '`'.$v.'` = '.$this->db->Quote($item[$v]);
                }
            }
            if ($field && !isset($siblings[$field])) {
                $query = 'SELECT '.$this->select_sql.
                ' FROM #__dataitems '.
                ' WHERE '.join(' AND ', $where).
                $group.
                $order;
                $this->db->setQuery($query, 0, $siblingcount);
                $siblings[$field] = $this->db->loadAssocList();
            }
        }

        return $siblings;
    }

    public function getFeedinfo()
    {
        echo 'depricated';

        return false;
    }

    public function getDataitems()
    {
        $a = microtime(true);
        if (null === $this->dataitems) {
            $this->_runQuery();
        }
        $b = microtime(true);
        $c = $b - $a;
        //echo "<!-- START $a STOP $b DELTA $c-->";
        return $this->dataitems;
    }

    public function _runQuery()
    {
        if (defined('ELASTIC')) {
            $this->elastic();

            return;
        }

        $this->dataitems = [];
        $dis = [];
        /* this woud be a sql eq running the query and loop below at once . tests showed that a single query ain't faster. Suggestions welkom !
         */
        $w = join(' and ', $this->where);
        $this->_getFoundRows($w);
        if (!$this->datacount) {
            return;
        }
        if ($this->group_select) {
            $query = 'SELECT '.$this->group_select.' AS s1 '.$this->group_order_select.
                                ' FROM #__dataitems'.
                                ' WHERE '.$w.
                                ' GROUP BY '.$this->group_select.
                                ' '.$this->group_order;
            $this->db->setQuery($query, $this->limitstart, $this->aantal);
            $dis = $this->db->loadAssocList();
            if (0 == count($dis)) {
                return;
            }
        } // todo make about query subquery
        if (is_array($dis) && $this->group_select && (!$this->smart_group || (count($dis) > 1))) {
            $this->is_grouped = true;
            $selects = [];
            if (defined('GROUPBYSELECT')) {
                foreach ($dis as $di) {
                    $selects[] = '('.$this->db->Quote($di['s1']).','.$this->db->Quote($di['value']).')';
                }
                $groepquery = ' ('.$this->group_select.' , '.$this->sorteer.') IN ('.join(',', $selects).') ';
            } else { // create an index on group_select and sorteer!
                foreach ($dis as $di) {
                    $selects[] = '('.$this->group_select.'='.$this->db->Quote($di['s1']).' AND '.$this->sorteer.' ='.$this->db->Quote($di['value']).')';
                }
                $groepquery = '('.join(' OR ', $selects).')';
            }
            $query = 'SELECT '.$this->select_sql.','.'COUNT(*) AS count'.
                                                ' FROM #__dataitems WHERE '.
                                                 $w.' AND '. //is this needed ? well yes 's1' might occur several times with
                                                                //the same hits but different field values
                                                                //s1=a,hits=10,S2=b s1=a,hits=10,s2=c
                                                $groepquery.
                                                ' GROUP BY '.$this->group_select.
                                                ' '.$this->order;
            $this->db->setQuery($query);
            $this->dataitems = $this->db->loadAssocList();
        } else {
            $query = 'SELECT  '.$this->select_sql.
                                ' FROM #__dataitems '.
                                ' where '.$w.
                                ' '.$this->order;
            $this->db->setQuery($query, $this->limitstart, $this->aantal);
            $this->dataitems = $this->db->loadAssocList();
        }
    }

    public function _getFoundRows($w)
    {
        // performance of FOUND ROWS depends on mysql version
        //
        //$this->db->setQuery('SELECT FOUND_ROWS();');  //no reloading the query! Just asking for total without limit

        if ($this->group_select) {
            $count = 'count(distinct '.$this->group_select.')';
        } else {
            $count = 'count(*)';
        }
        $this->db->setQuery('SELECT '.$count.' AS c FROM #__dataitems WHERE  '.$w);
        $this->datacount = $this->db->loadResult();
    }

    public function getDatacount()
    {
        if (!is_array($this->where)) {
            return -1;
        }
        if (!$this->datacount) {
            $this->getDataitems();
            //echo '<!-- count ' . $this->datacount . '-->';
        }

        return $this->datacount;
    }

    public function getWhere($basic = false)
    {
        $where = [];
        $slug = '';
        for ($v = 9; $v >= 1; --$v) {
            if ($this->select[$v]) {
                if (is_array($this->select[$v])) {
                    foreach ($this->select[$v] as $value) {
                        $slug .= "&q$v".'[]='.urlencode($value);
                    }
                } else {
                    $slug .= "&q$v=".urlencode($this->select[$v]);
                    // use title
                //$where['q'.$v]=$this->select[$v];
                }
            }
        }
        $where['qt'] = $this->select['t'];
        $where['q'] = $this->select['q'];

        if ($this->select['q']) {
            $slug .= '&q='.urlencode($this->select['q']);
        }
        $where['slug'] = $slug;
        $where['baselink'] = $this->baselink;
        $where['menu_id'] = $this->menu_id;
        $where['sort'] = $this->sorteer;
        if ($basic) {
            return $where;
        }
        $where['linkmerchant'] = $this->params->get('feed_link_merchant', 0);
        $where['feed_path'] = $this->params->get('feed_path', '1,2,3');
        $where['currency_sign'] = $this->params->get('currency_sign', '&euro;');
        $where['read_more'] = $this->params->get('read_more', 'Read More...');
        $where['pb'] = $this->params->get('comlink', true);
        $where['fields'] = $this->fields;
        if ($this->limitstart > 0) {
            // in principe is limitstart altijd een veelvoud van aantal
            // behalve is de config gewijzigd is dus toch maar een floor
            $s = floor($this->limitstart / $this->aantal) + 1;
            $t = ceil($this->datacount / $this->aantal);
            if (defined('DF_PAGELIMIT')) {
                $t = min($t, DF_PAGELIMIT);
            }

            $pagestring = $this->params->get('pagestring', JText::_('JLIB_HTML_PAGE_CURRENT_OF_TOTAL'));

            $this->title['page'] = sprintf($pagestring, $s, $t);
        }
        $where['title'] = $this->title;
        $where['aantal'] = $this->aantal;
        $where['level'] = $this->where_level; // the number of menu levels adressed in the query
        $where['next_level'] = $this->maxq + 1; // highest menu level address in the query plus one, so the first unqueried
        $where['chain'] = $this->chain; // highest menu level address in the query plus one, so the first unqueried
        $where['is_grouped'] = $this->is_grouped; // highest menu level address in the query plus one, so the first unqueried
        $where['singleitem'] = $this->singleitem;
        $where['limitstart'] = $this->limitstart;
        if ($where['count'] = $this->getDatacount()) {
            $where['template'] = $this->where_level ? $this->params->get('template1', 'full') : $this->params->get('template', 'full');
        } else {
            $where['template'] = 'nothing';
        }

        return $where;
    }

    public function setPathway()
    {
        $baselink = $this->baselink;
        $app = JFactory::getApplication();
        $pathway = $app->getPathway();
        //$pathway->addItem($this->name, $baselink);

        for ($v = 1; $v <= 9; ++$v) {
            $q = $this->select[$v]??'';
            if ($q) {
                $baselink .= "&q$v=".urlencode($q);
                $pathway->addItem($this->title[$v], $baselink);
            }
        }
        $q = $this->select['q']??'';
        if ($q) {
            $baselink = $this->baselink.'&q='.urlencode($q);
            $pathway->addItem($q, $baselink);
        }
        $q = $this->select['t']??'';
        if ($q) {
            $baselink = $this->baselink.'&qt='.urlencode($q);
            $pathway->addItem($q, $baselink);
        }
        $q = $this->select['f']??'';
        if ($q) {
            $baselink = $this->baselink.'&qf='.urlencode($q);
            $pathway->addItem($q, $baselink);
        }
    }

    public function getPagination()
    {
        if ((($count = $this->getDatacount()) > $this->aantal) &&
        ($this->multipagina) && ('component' != $this->getVar('tmpl'))) {
            if (empty($this->_pagination)) {
                if (defined('DF_PAGELIMIT')) {
                    $count = min($count, DF_PAGELIMIT * $this->aantal);
                }
                $this->_pagination = new JPagination($count, $this->limitstart, $this->aantal);
            }
        } else {
            $this->_pagination = null;
        }

        return $this->_pagination;
    }

    public function getNext($id = 0)
    {
        $query = 'SELECT '.$this->select_sql.
                                ' FROM #__dataitems '.
                                ' where '.$this->where_group. //dankzij group_select altijd minsten 1
                                ' AND items_id > '.(int) $id;
        $this->db->setQuery($query, 0, 1);
        $next = $this->db->loadAssoc();

        return $next;
    }

    public function getRelated($q = '', $limit = 10, $order = 'hits desc')
    {
        $query = 'SELECT '.$this->select_sql.
                                ' FROM #__dataitems '.
                                ' where '.$this->where_group; //dankzij group_select altijd minsten 1
        if ($q) { // only developers will add/call this function they must check
            $query .= ' AND ('.$q.') ';
        }
        if ($order) { // only developers will add/call this function they must check
            $query .= ' ORDER BY '.$order.' ';
        }

        $this->db->setQuery($query, 0, $limit);
        $next = $this->db->loadAssocList();

        return $next;
    }

    public function elastic()
    {
        if (defined('ELASTIC')) {
            require('elastic.php');
        }
    }
}
