<?php

//
// Copyright brambring.nl
// https://affiliatefeeds.nl
// joomla@brambring.nl

//remove from here
use Joomla\CMS\Component\Router\RouterBase;

if (file_exists(dirname(__FILE__).'/xrouter.php')) {
    include_once dirname(__FILE__).'/xrouter.php';
} else {
    class DatafeedsRouter extends routerbase
    {
        function build(&$query)
        {
            $segments = [];

            $broken = false;

            if (isset($query['id']) && isset($query['qt'])
            && ($query['id'] && $query['qt'])) {
                $segments[] = $query['id'];
                $segments[] = $query['qt'];
                unset($query['qt']);
                unset($query['id']);
            } else {
                if (isset($query['id'])) {
                    if ($query['id']) {
                        $segments[] = $query['id'];
                        $broken = true;
                    }
                    unset($query['id']);
                } elseif (isset($query['q1']) && is_numeric($query['q1'])) {
                    $broken = true;
                }
            }
            if (isset($query['qt'])) {
                if ($query['qt']) {
                    $segments[] = 't-'.$query['qt'];
                    $broken = false;
                }
                unset($query['qt']);
            }
            if (isset($query['q'])) {
                if ($query['q']) {
                    $segments[] = 'q-'.$query['q'];
                }
                unset($query['q']);
            }

            if (isset($query['q0'])) {
                unset($query['q0']);
            }

            for ($v = 1; $v <= 9; ++$v) { // 9 levels
                if (isset($query['q'.$v])) {
                    $q = $query['q'.$v];
                    unset($query['q'.$v]);
                    if ($q) {
                        if ($broken || (false !== strpos($q, '-'))) {
                            $segments[] = $v.'-'.$q;
                            $broken = false;
                        } else {
                            $segments[] = $q;
                        }
                    } else {
                        $broken = true;
                    }
                } else {
                    $broken = true;
                }
            }
            if (isset($query['start'])) {
                $query['limitstart'] = $query['start'];
                unset($query['start']);
            }
            if (isset($query['format']) && ('html' === $query['format'])) {
                unset($query['format']);
            }
            if (isset($query['limitstart']) && ($query['limitstart'] > 0)) {
                $segments[] = 'start'.$query['limitstart'];
            }
            unset($query['limitstart']);
            unset($query['view']);
            if (isset($query['task']) && 'component' == $query['task']) {
                unset($query['task']);
            }

            return str_replace(' ', '+', $segments); // you CAN NOT change this into '-'
        }
        function parse(&$segments)
        {
            $vars = [];
            //We quoten $segments=str_replace(array('"',"'",';')," ",$segments);
            if (preg_match('/^start([0-9]+)/', $segments[count($segments) - 1], $m)) {
                //$vars['start']= $m[1];
                $vars['limitstart'] = $m[1];
                array_pop($segments);
            }
            $count = 0;
            if ($segments && is_numeric($segments[0])) {
                $vars['id'] = array_shift($segments);
                if ($segments[0]) {
                    if (false === strpos($segments[0], ':')) {
                        $vars['qt'] = array_shift($segments);
                    }
                }
            }
            while ($segments && $v = array_shift($segments)) {
                if (preg_match('/^([0-9tq]+)[:\-](.+)/', $v, $a)) {
                    $count = $a[1];
                    $v = $a[2];
                } else {
                    ++$count;
                }
                if ('q' == $count) {
                    $vars['q'] = $v;
                    $count = 0;
                } else {
                    $vars['q'.$count] = $v;
                }
                if ('t' == $count) {
                    //de title komt altijd als eerste
                    $count = 0;
                }
            }
            return str_replace('+', ' ', $vars);
        }
    }
    //remove from here
}
//remove to here
