<?php

//
// Copyright brambring.nl
// https://affiliatefeeds.nl
// joomla@brambring.nl
//

throw new GenericDataException(JText::_('Error Loading Modules').$db->getErrorMsg(), 500);
class DatafeedsViewItems extends JViewLegacy
{
    public function display($tpl = null)
    {
        $app = JFactory::getApplication();
        $jinput = $app->input;

        $path = dirname(__FILE__).'/rss.php';
        if (file_exists($path)) {
            require_once $path;
        } else {
            throw new GenericDataException(JText::_('Unable to load renderer class').$db->getErrorMsg(), 500);
            return false;
        }

        $doc = JFactory::getDocument();
        $rows = $this->get('Dataitems');
        $where = $this->get('Where');
        $title = htmlentities(df_title($doc->getTitle(), $where['title']));
        $doc->setTitle($title);
        //doc->setGenerator( "Joomla datafeed parser www.affiliatefeeds.nl ");

        $doc->link = JRoute::_($where['baselink'].$where['slug']);
        $uri = JURI::getInstance();
        $root = $uri->toString(['scheme', 'host', 'port']);

        $jinput->setVar('limit', $app->getCfg('feed_limit'));

        foreach ($rows as $row) {
            // strip html from feed item title
            $title = $this->escape($row['title']);
            $title = html_entity_decode($title);

            // url link to article
            //
            //
            $s0 = $row['s0']??'';
            $s1 = $row['s1']??'';
            $s2 = $row['s2']??'';
            $s3 = $row['s3']??'';
            $u1 = urlencode($s1);
            $u2 = urlencode($s2);
            $u3 = urlencode($s3);
            if ($where['linkmerchant']) {
                $link = JRoute::_($row['url']);
            } else {
                //zo netter in het model zijn.
                $l = $where['baselink'];
                foreach (explode(',', $where['feed_path']) as $v) {
                    $l .= "&q$v=".urlencode($row[$where['fields'][$v]]??'');
                }
                $l .= '&qt='.urlencode($row['title']??'');
                $link = JRoute::_($l);
            }

            $image = $row['image'];

            if (false === strstr($link, 'http')) {
                $link = $root.$link;
            }

            $description = '';
            if ($image) {
                $description .= '<a href="'.$link.'"><img loading="lazy"  width="25%"  align="left" hspace="15" vspace="0" src="'.$image.'" alt="'.$title.'" /></a>';
            }
            $description .= $row['description'];
            $description .= sprintf('<p class="prijs"><span>'.$where['currency_sign'].'  %2.2f</span></p>', $row['price']);
            if ($where['linkmerchant']) {
                if ($s1) {
                    $description .= '<strong>';
                    $description .= "<a href='".$root.JRoute::_($where['baselink']."&q1=$u1")."'>$s1</a>";
                    if ($s2 && 'Divers' != $s2) {
                        $description .= " <a href='".$root.JRoute::_($where['baselink']."&q1=$u1&q2=$u2")."'>$s2</a>";
                    }
                    if ($s3 && 'Divers' != $s3) {
                        $description .= " <a href='".$root.JRoute::_($where['baselink']."&q1=$u1&q2=$u2&q3=$u3")."'>$s3</a>";
                    }
                }
                $description .= '</strong><br CLEAR=ALL/>';
            }
            $date = !empty($row['adddate']) ? date('r', strtotime($row['adddate'])) : '';

            // load individual item creator class
            //$description = $this->escape( $description );
            //$description = html_entity_decode( $description );

            $item = new JFeedItem();
            $item->title = $title;
            $item->link = $link;
            $item->guid = $link;
            $item->description = $description;

            $item->date = $date;
            $item->category = "$s0,$s1,$s2,$s3";

            // loads item info into rss array
            $doc->addItem($item);
        }
        echo $doc->render();
    }
}
